<?php

/**
 * abono_concepto actions.
 *
 * @package    cobro_coactivo
 * @subpackage abono_concepto
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class abono_conceptoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_ABONO_CONCEPTO',
        'CBR_REGISTRO_CONCEPTO',
        'CBR_CONCEPTO_DEUDA'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'id_registro_concepto' => 'CBR_ABONO_CONCEPTO'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'id_concepto_deuda' => 'CBR_REGISTRO_CONCEPTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_ABONO_CONCEPTO' =>
        array(
            'id_abono_concepto' => 'id_abono_concepto',
            'id_registro_concepto' => 'id_registro_concepto',
            'numero' => 'numero',
            'fecha_abono' => 'fecha_abono',
            'valor_abono' => 'valor_abono',
        ),
        'CBR_REGISTRO_CONCEPTO' =>
        array(
            'valor' => 'valor_total',
            'abonos' => 'abonos_total',
            'saldo' => 'saldo_total'
        )
        ,
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'descripcion' => 'descripcion_concepto'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'fecha_abono', 'numero'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_ABONO_CONCEPTO' =>
        array(
            'id_abono_concepto,a' => array('!=' => array(-1)),
            'id_abono_concepto,b' => array('=' => array('id_abono_concepto')),
            'id_registro_concepto,b' => array('=' => array('id_registro_concepto')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_abono_concepto'; //identificador de la tabla
    protected $id_names = array('id_abono_concepto'); //llave primaria
    protected $field_names = array('id_registro_concepto', 'numero', 'fecha_abono',
        'valor_abono'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_ABONO_CONCEPTO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_abono_concepto'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_registro_concepto = $list_data_post[0]['id_registro_concepto'];
                $valor_abono = $list_data_post[0]['valor_abono'];

                $sql = <<<EOD
UPDATE CBR_REGISTRO_CONCEPTO SET ABONOS = ABONOS + $valor_abono, SALDO = SALDO - $valor_abono
EOD;

                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_registro_concepto = $request['id_registro_concepto'];
        $valor_abono = $request['valor_abono'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
select
cont.id_registro_concepto,
cont.valor as valor,
sum(novdes.valor_abono) as valor_abono

from cbr_registro_concepto cont

left join cbr_abono_concepto novdes
on novdes.id_registro_concepto = cont.id_registro_concepto

where
cont.id_registro_concepto = $id_registro_concepto

group by
cont.id_registro_concepto,
cont.valor 
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida abono no supere total - 20200224
        if (count($records) > 0) {

            $valor = $records[0]['valor'];
            $valor_abono_cont = $records[0]['valor_abono'];

            if (($valor_abono_cont + $valor_abono) > $valor) {

                $valor_abono_text = number_format($valor_abono);
                $valor_total_text = number_format($valor);

                $errors['mensaje'] = "El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.";
                $errors['servicio'] = "abono_concepto";
                $logger->info("El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.");
            }
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
